/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package aspectModel;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Advice Application Conditions</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see aspectModel.AspectModelPackage#getAdviceApplicationConditions()
 * @model
 * @generated
 */
public enum AdviceApplicationConditions implements Enumerator {
	/**
	 * The '<em><b>Global</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GLOBAL_VALUE
	 * @generated
	 * @ordered
	 */
	GLOBAL(1, "Global", "Global"),

	/**
	 * The '<em><b>Per Join Point</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PER_JOIN_POINT_VALUE
	 * @generated
	 * @ordered
	 */
	PER_JOIN_POINT(0, "PerJoinPoint", "PerJoinPoint"),

	/**
	 * The '<em><b>On Demand</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ON_DEMAND_VALUE
	 * @generated
	 * @ordered
	 */
	ON_DEMAND(2, "OnDemand", "OnDemand"),

	/**
	 * The '<em><b>Per Scope</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PER_SCOPE_VALUE
	 * @generated
	 * @ordered
	 */
	PER_SCOPE(3, "PerScope", "PerScope");

	/**
	 * The '<em><b>Global</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Global</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #GLOBAL
	 * @model name="Global"
	 * @generated
	 * @ordered
	 */
	public static final int GLOBAL_VALUE = 1;

	/**
	 * The '<em><b>Per Join Point</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Per Join Point</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PER_JOIN_POINT
	 * @model name="PerJoinPoint"
	 * @generated
	 * @ordered
	 */
	public static final int PER_JOIN_POINT_VALUE = 0;

	/**
	 * The '<em><b>On Demand</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>On Demand</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ON_DEMAND
	 * @model name="OnDemand"
	 * @generated
	 * @ordered
	 */
	public static final int ON_DEMAND_VALUE = 2;

	/**
	 * The '<em><b>Per Scope</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Per Scope</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PER_SCOPE
	 * @model name="PerScope"
	 * @generated
	 * @ordered
	 */
	public static final int PER_SCOPE_VALUE = 3;

	/**
	 * An array of all the '<em><b>Advice Application Conditions</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final AdviceApplicationConditions[] VALUES_ARRAY =
		new AdviceApplicationConditions[] {
			GLOBAL,
			PER_JOIN_POINT,
			ON_DEMAND,
			PER_SCOPE,
		};

	/**
	 * A public read-only list of all the '<em><b>Advice Application Conditions</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<AdviceApplicationConditions> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Advice Application Conditions</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static AdviceApplicationConditions get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			AdviceApplicationConditions result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Advice Application Conditions</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static AdviceApplicationConditions getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			AdviceApplicationConditions result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Advice Application Conditions</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static AdviceApplicationConditions get(int value) {
		switch (value) {
			case GLOBAL_VALUE: return GLOBAL;
			case PER_JOIN_POINT_VALUE: return PER_JOIN_POINT;
			case ON_DEMAND_VALUE: return ON_DEMAND;
			case PER_SCOPE_VALUE: return PER_SCOPE;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private AdviceApplicationConditions(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //AdviceApplicationConditions
